#include <Windows.h>
#include <tchar.h>
#include <dsound.h>
#include <math.h>
#include <stdio.h>

#include "CensorIO.h"


IDirectSound8 *pDS8 = 0;
IDirectSoundBuffer8 *pDSBuffer = 0;
DWORD playHz = 44100;
float baseHz = 880.0f;
float highHz = 44100;
float oct = 5.0f;
float lowHz = highHz / powf( 2.0f, oct );	// 3IN^[u

// ZT[̒lɑΉ̎gvZ
DWORD calcHz( unsigned x ) {
	float unit = oct / 255.0f;
	float mult = powf( 2.0f, unit * x );
	return (DWORD)( lowHz * mult );
}

// \[XƂȂg쐬ibitrate 16bitOj
WORD* createSourceWave( DWORD samplePerSec, float time, float hz ) {

	unsigned int valueNum = (unsigned int)( samplePerSec / time );
	WORD *mem = new WORD[ valueNum ];

	float dt = 1.0f / samplePerSec;
	float _2Pi = 3.14159265358979f * 2.0f;
	WORD maxVal = (WORD)-1;
	for ( unsigned int i = 0; i < valueNum; i++ ) {
		float t = dt * i * hz;
		float v = ( sinf( _2Pi * t ) + 1.0f ) * 0.5f * maxVal;
		mem[ i ] = (WORD)v;
	}

	return mem;
}

bool initializeSound( HWND hWnd ) {

	// TEhfoCX쐬
    DirectSoundCreate8( NULL, &pDS8, NULL );
    pDS8->SetCooperativeLevel( hWnd, DSSCL_PRIORITY );

	// ZJ_obt@쐬
	WAVEFORMATEX wFmt;
	wFmt.wFormatTag = WAVE_FORMAT_PCM;
	wFmt.nChannels = 1;
	wFmt.nSamplesPerSec = playHz;
	wFmt.wBitsPerSample = 16;
	wFmt.nBlockAlign = wFmt.nChannels * wFmt.wBitsPerSample / 8;
	wFmt.nAvgBytesPerSec = wFmt.nSamplesPerSec * wFmt.nBlockAlign;
	wFmt.cbSize = 0;

    DSBUFFERDESC DSBufferDesc;
    DSBufferDesc.dwSize = sizeof( DSBUFFERDESC );
    DSBufferDesc.dwFlags = DSBCAPS_CTRLFREQUENCY;
    DSBufferDesc.dwBufferBytes = wFmt.nSamplesPerSec * wFmt.wBitsPerSample * wFmt.nChannels / 8 * 1; //  1 sec.
    DSBufferDesc.dwReserved = 0;
    DSBufferDesc.lpwfxFormat = &wFmt;
    DSBufferDesc.guid3DAlgorithm = GUID_NULL;

    IDirectSoundBuffer *ptmpBuf = 0;
    pDS8->CreateSoundBuffer( &DSBufferDesc, &ptmpBuf, NULL );
    ptmpBuf->QueryInterface( IID_IDirectSoundBuffer8 ,(void**)&pDSBuffer );
    ptmpBuf->Release();
    if ( pDSBuffer == 0 ) {
		pDS8->Release();
		return false;
    }

	WORD *pWaveData = createSourceWave( wFmt.nSamplesPerSec, 1.0f, baseHz );

    LPVOID lpvWrite = 0;
    DWORD dwLength = 0;
    if ( DS_OK == pDSBuffer->Lock( 0, 0, &lpvWrite, &dwLength, NULL, NULL, DSBLOCK_ENTIREBUFFER ) ) {
		memcpy( lpvWrite, pWaveData, dwLength );
		pDSBuffer->Unlock( lpvWrite, dwLength, NULL, 0);
    }

	delete pWaveData; // ͂Ȃ

	pDSBuffer->Play( 0, 0, DSBPLAY_LOOPING );

	return true;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam){
		switch( mes ) {
		case WM_DESTROY:
			PostQuitMessage( 0 );
			return 0;
		}
        return DefWindowProc(hWnd, mes, wParam, lParam);
}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	const char* windowName = "Sound Test";
    MSG msg; HWND hWnd;
    WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL,
                                (HBRUSH)(COLOR_WINDOW+1), NULL, (TCHAR*)windowName, NULL};
    if(!RegisterClassEx(&wcex)) return 0;

    if(!(hWnd = CreateWindow(windowName, windowName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
                    NULL, NULL, hInstance, NULL)))
        return 0;


	initializeSound( hWnd );

	::ShowWindow( hWnd, SW_SHOW );

	// ArduinoƂ̃VAʐMJn
	CensorIO censor;
	censor.open();

	// bZ[W [v
	HDC dc = ::GetDC( hWnd );
	do {
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) { 
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		} else {
			int v = censor.getValue();
			DWORD hz = calcHz( v );
			if ( v >= 0 )
				pDSBuffer->SetFrequency( calcHz( v ) );

			char c[256];
			sprintf_s( c, 256, "Censor output: %03d, Sample Hz: %05d, Hz: %05d   ", v, hz, (DWORD)(baseHz * hz / 44100.0f) );
			::TextOutA( dc, 0, 0, c, strlen( c ) );
		}
	} while( msg.message != WM_QUIT );

	censor.close();

	ReleaseDC( hWnd, dc );

	return 0;
}